## rustc-1.89 1.89.0%2Bdfsg0ubuntu1

=== src/tools/enzyme/enzyme/test/Integration/Sparse/CMakeLists.txt ===
# Run regression and unit tests
add_lit_testsuite(check-enzyme-integration-sparse "Running enzyme spare integration tests"
    ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ClangEnzyme-${LLVM_VERSION_MAJOR}
    ARGS -v
)

set_target_properties(check-enzyme-integration-sparse PROPERTIES FOLDER "Tests")

#add_lit_testsuites(ENZYME ${CMAKE_CURRENT_SOURCE_DIR}
    #    DEPENDS ${ENZYME_TEST_DEPS}
#)

## rustc-1.89 1.89.0+dfsg~24.04

=== debian/changelog ===
rustc-1.89 (1.89.0+dfsg~24.04-0ubuntu0.24.04.1) noble-security; urgency=medium

  * Backport Rust 1.89 to Noble Numbat (LP: #2138316)
    - Downgrade libgit2 to 1.7.2
    - Replace system LLVM dependencies with vendored version
    - Vendor dh-cargo-vendored-sources to use specific cargo version

 -- Brent Kerby <brent.kerby@canonical.com>  Thu, 04 Dec 2025 12:48:40 -0700

rustc-1.89 (1.89.0+dfsg0ubuntu2-0ubuntu1) resolute; urgency=medium

  * Fix vendored dependency stub format (LP: #2132631)
    - d/prune-unused-deps: Reverse cargo-vendor-filterer overhaul
    - d/{rules,vendor-deps}: Generate dep stubs with another tarball
    - d/p/series: Remove obsolete dependency stub generation patch
    - d/add-vendored-copyright-overrides: Create script to automatically add
      the lintian overrides for all missing copyright stanzas of vendored
      crate stubs
    - d/copyright: Remove obsolete autogenerated Files-Excluded
    - d/copyright: Move vendor Files-Excluded to special component section
    - d/source/lintian-overrides: Add section for crate stub overrides
  * New upstream version 1.89.0+dfsg0ubuntu2 (repacked using new d/vendor-deps
    method)
  * d/control: Update XS-Vendored-Sources-Rust
  * d/copyright: Fix overzealous copyright stanza glob matches
  * d/source/lintian-overrides: Add copyright overrides for crate stubs

 -- Max Gilmour <max.gilmour@canonical.com>  Thu, 27 Nov 2025 15:31:31 -0800

rustc-1.89 (1.89.0+dfsg0ubuntu1-0ubuntu1) resolute; urgency=medium

  * New upstream version 1.89.0 (LP: #2121623)
  * Standard maintenance:
    - d/patches/*: refresh patches after upstream update
    - d/p/prune/d-0020-remove-windows-dependencies.patch: prune Windows
      dependencies from Rust source
    - d/control,d/s/lintian-overrides: update version numbers
    - d/copyright: update Files-Excluded with pruned vendored dependencies
    - d/patches/*: refresh patches after pruning vendored deps
    - d/control: update XS-Vendored-Sources-Rust
    - d/copyright: update vendor copyright stanzas
  * Orig tarball fixes:
    - d/copyright: exclude Enzyme benchmarks from orig tarball
    - d/copyright: comment out unneeded binary blob exclusion
  * Drop unneeded patches:
    - d/p/series: drop patches necessary only for GNU Hurd
    - d/p/series: drop upstream/u-raw-rustc-command.patch (applied upstream)
  * Remove duplicates of control files:
    - d/rules: overhaul update-version rule to work with versioned package
    - d/update-version.sh: overhaul script to update d/control and
      d/s/lintian-overrides
    - d/control.in,d/s/lintian-overrides.in: delete .in files duplicating
      existing control files
  * Automate vendored crate pruning with cargo-vendor-filterer:
    - d/prune-unused-deps: overhaul script to use cargo-vendor-filterer
    - d/p/prune/d-0021-vendor-remove-windows-dependencies.patch: Drop obsolete
      patch manually pruning Windows dependencies
    - d/p/series,d/p/prune/d-0021-add-pruned-dep-stubs.patch: add
      autogenerated patch creating stubs for pruned deps
  * d/p/no-version-string-in-feature-removed-help.patch: don't include current
    version string in feature removed help messages (cherry-pick which will be
    applied upstream in 1.90)
  * d/p/build/d-bootstrap-tests-restrict-defaults.patch: fix incorrect field
    name for overwriting the default bootstrap test configuration
  * Point cargo wrapper script to versioned cargo instead of default
    - d/rules: add .in files in subdirectories to FILES_TO_PRECONFIGURE
    - d/rules: make preconfigured files' permissions match their originals
    - d/cargo.in: point cargo wrapper script to versioned cargo

 -- Max Gilmour <max.gilmour@canonical.com>  Fri, 17 Oct 2025 15:04:06 -0700

rustc-1.88 (1.88.0+dfsg0ubuntu1-0ubuntu1) questing; urgency=medium

  * New upstream version 1.88.0 (LP: #2120340)
  * Standard maintenance:
    - debian/patches: Early-stage patch refresh
    - d/p/prune/d-0021-vendor-remove-windows-dependencies.patch: Prune Windows
      dependencies of vendored crates
    - d/control,d/s/lintian-overrides: Update versioned identifiers
    - d/copyright: Update Files-Excluded with newly-pruned vendored crates
    - d/control,d/control.in: Update XS-Vendored-Sources-Rust
  * Drop unneeded patches:
    - d/p/upstream/u-fix-get-toml-when-test.patch: Fixed upstream
    - d/p/ubuntu/ubuntu-disable-ppc64el-asm-tests.patch: Failing tests were
      removed upstream
    - d/p/upstream/u-profiler-builtins-full-path.patch: Fixed upstream
    - d/p/upstream/u-run-make-support-dylib.patch: Fixed upstream
  * d/copyright: Update Files-Excluded list for new mdbook version
  * Fix bootstrap tests:
    - d/p/series,d/p/build/d-bootstrap-tests-restrict-defaults.patch: Restrict
      default config values for bootstrap tests
    - d/p/series,d/p/build/d-disable-git-bootstrap-tests.patch: Disable tests
      which require an upstream Git repo

 -- Max Gilmour <max.gilmour@canonical.com>  Fri, 22 Aug 2025 15:42:22 -0700

rustc-1.87 (1.87.0+dfsg0ubuntu1-0ubuntu1) questing; urgency=medium

  * New upstream version 1.87.0 (LP: #2118790)
  * Standard maintenance:
    - d/patches: Refresh patches
    - d/p/prune/d-0021-vendor-remove-windows-dependencies.patch: Prune Windows
      dependencies of vendored crates
    - d/control,d/s/lintian-overrides: Update versioned identifiers
    - d/copyright: Update Files-Excluded with newly-pruned vendored crates
    - d/control,d/control.in: Update XS-Vendored-Sources-Rust
    - d/copyright: Update copyright stanzas
  * d/copyright: Remove src/tools/rls from Files-Excluded (dropped upstream)
  * Upgrade to LLVM 20:
    - d/p/ubuntu/ubuntu-enzyme-use-system-llvm.patch: Make LLVM_DIR llvm-20
    - d/rules,d/bin/rust-lld,d/control,d/*.in: Update LLVM references to
      version 20
  * Rename config.toml to bootstrap.toml:
    - d/copyright,d/rust-X.Y-src.install.in: Rename config.example.toml to
      bootstrap.example.toml


=== debian/control ===
Source: rustc-1.89
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Fabian Grünbichler <debian@fabian.gruenbichler.email>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
 dh-cargo (>= 28ubuntu1~),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo-1.88 | cargo-1.89 <!pkg.rustc.dlstage0>,
 rustc-1.88 | rustc-1.89 <!pkg.rustc.dlstage0>,
 cmake (>= 3.0) | cmake3,
# needed by some vendor crates
 pkgconf,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# used by cargo
 bash-completion,
 libcurl4-gnutls-dev | libcurl4-openssl-dev,
 libssh2-1-dev,
 libgit2-dev (>= 1.7.2~~),
 libgit2-dev (<< 1.8~~),
 libhttp-parser-dev,
 libsqlite3-dev,
 libonig-dev,
# Required for llvm build
 autotools-dev,
 m4,
 ninja-build,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.6.2
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# The build regressed back when LTO was systematized in Ubuntu.
# This should be periodically revisited.
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
RUST_PREV_VERSION=$(shell echo '$(RUST_LONG_VERSION)' | awk 'BEGIN{FS="."} {print $$1"."($$2)-1}')
RUST_NEXT_VERSION=$(shell echo '$(RUST_LONG_VERSION)' | awk 'BEGIN{FS="."} {print $$1"."($$2)+1}')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc-[0-9][0-9.]\+ .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

# The versioned package name read from d/changelog.
PKG_NAME_CHANGELOG := $(shell dpkg-parsechangelog -S Source)
# The versioned package name read from d/control.
PKG_NAME_CONTROL := $(shell sed -n 's/^Source: \(rustc-[0-9][0-9.]\+\).*/\1/p' debian/control)
# The upstream source code version.
DEFINED_SRC_VERSION := $(shell cut -f1 -d' ' < $(CURDIR)/version)

VENDOR_TARBALL := $(PKG_NAME_CHANGELOG)_$(DEB_VERSION_UPSTREAM).orig-vendor.tar.xz
# This is a temporary directory used to store the filtered vendored dependencies.
# It is packed into the vendor tarball.
FILTERED_DEPS := $(CURDIR)/../vendor

include /usr/share/dpkg/buildflags.mk
# needed for cross-compilation to avoid passing host CFLAGS to the BUILD
# compiler
export TARGET_CFLAGS = $(CFLAGS)
export TARGET_CXXFLAGS = $(CXXFLAGS)
export TARGET_CPPFLAGS = $(CPPFLAGS)
export TARGET_LDFLAGS = $(LDFLAGS)
unexport CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
# for dh_install substitution variable
export DEB_HOST_RUST_TYPE

# Let rustbuild control whether LLVM is compiled with debug symbols, rather
# than compiling with debug symbols unconditionally, which will fail on
# 32-bit architectures
CFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
CXXFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')

# for dh_install substitution variable
export RUST_LONG_VERSION
export RUST_VERSION

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Use system LLVM (comment out to use vendored LLVM)
# LLVM_VERSION = 20
# OLD_LLVM_VERSION = $(shell echo "$$(($(LLVM_VERSION)-1))")
# # used by the upstream profiler build script
# CLANG_RT_TRIPLE := $(shell llvm-config-$(LLVM_VERSION) --host-target)
# LLVM_PROFILER_RT_LIB = /usr/lib/clang/$(LLVM_VERSION)/lib/$(CLANG_RT_TRIPLE)/libclang_rt.profile.a
# ifneq ($(wildcard $(LLVM_PROFILER_RT_LIB)),)
# # Clang per-target layout
# export LLVM_PROFILER_RT_LIB := /../../$(LLVM_PROFILER_RT_LIB)
# else
# # Clang legacy layout
# CLANG_RT_ARCH := $(shell echo '$(CLANG_RT_TRIPLE)' | cut -f1 -d-)
# ifeq ($(DEB_HOST_ARCH),armhf)
# CLANG_RT_ARCH := armhf
# endif
# export LLVM_PROFILER_RT_LIB := /usr/lib/clang/$(LLVM_VERSION)/lib/linux/libclang_rt.profile-$(CLANG_RT_ARCH).a
# endif

# Cargo-specific flags
export LIBSSH2_SYS_USE_PKG_CONFIG=1

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH),riscv64)
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NJOBS := -j 4
endif
endif
RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py $(NJOBS)
RUSTBUILD_FLAGS = --stage 2 --config debian/bootstrap.toml --on-fail env
# rust-tidy depends on lots of modules that we strip out of the build.
# it also tries to access the network for some reason. so just disable it.
RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast --exclude src/tools/tidy
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

# https://github.com/rust-lang/rust/issues/89744
# TODO: remove when we update cargo to 1.55 / 0.56
# upstream bug still exists and is under investigation, but is hidden by newer cargo
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=0

# autopkgtest-related logic
ifneq (,$(RUST_TEST_SELFBUILD))
RUST_BOOTSTRAP_DIR = /usr/lib/rust-$(RUST_VERSION)
endif

.PHONY: vendor-tarball-quick-check
vendor-tarball-quick-check:
	if [ -e $(CURDIR)/../$(VENDOR_TARBALL) ]; then \
		echo "../$(VENDOR_TARBALL) already exists" >&2; \
		exit 1; \
	fi

.PHONY: vendor-deps
vendor-deps:
	debian/vendor-deps $(FILTERED_DEPS)

.PHONY: vendor-tarball
vendor-tarball: vendor-tarball-quick-check vendor-deps
	tar --sort=name --mtime=@0 --owner=0 --group=0 --numeric-owner --pax-option=exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime -caf $(CURDIR)/../$(VENDOR_TARBALL) $(FILTERED_DEPS)
	mk-origtargz --rename -c vendor $(CURDIR)/../$(VENDOR_TARBALL)
	rm -rf $(FILTERED_DEPS)

update-version: check-changelog-matches-upstream
ifeq ($(PKG_NAME_CONTROL),rustc-$(RUST_VERSION))
	$(error The source package version in d/control already matches the upstream code version)
endif
	old_bootstrap=$(shell \
		$(SED_RUSTC_BUILDDEP) | \
		grep -o 'rustc-[0-9][0-9.]\+' | \
		sed 's/^rustc-//' | \
		sort -V | \
		head -n1 \
	); \
	oldver=$(RUST_PREV_VERSION); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$old_bootstrap $$oldver $$newver

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_BOOTSTRAP_DIR))
        RUST_LIBRARY_PATH := $(RUST_BOOTSTRAP_DIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_BOOTSTRAP_DIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \

## rustc-1.89 1.89.0+dfsg0ubuntu1

=== src/tools/enzyme/enzyme/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(Enzyme)

include(CMakePackageConfigHelpers)
include(CheckIncludeFile)
include(CheckIncludeFileCXX)

set(ENZYME_MAJOR_VERSION 0)
set(ENZYME_MINOR_VERSION 0)
set(ENZYME_PATCH_VERSION 79)
set(ENZYME_VERSION
  ${ENZYME_MAJOR_VERSION}.${ENZYME_MINOR_VERSION}.${ENZYME_PATCH_VERSION})

add_definitions(-DENZYME_VERSION_MAJOR=${ENZYME_MAJOR_VERSION})
add_definitions(-DENZYME_VERSION_MINOR=${ENZYME_MINOR_VERSION})
add_definitions(-DENZYME_VERSION_PATCH=${ENZYME_PATCH_VERSION})

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if (NOT DEFINED ENZYME_CONFIGURED_WITH_PRESETS)
  set(CMAKE_CXX_FLAGS "-Wall -fno-rtti ${CMAKE_CXX_FLAGS} -Werror=unused-variable -Werror=dangling-else -Werror=unused-but-set-variable -Werror=return-type -Werror=nonnull -Werror=unused-result -Werror=reorder -Werror=switch")
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g -ggdb")
  set(CMAKE_CXX_FLAGS_RELEASE "-O2")
  set(CMAKE_CXX_FLAGS_DEBUG  "-O0 -g -ggdb -fno-omit-frame-pointer")
endif()

#SET(CMAKE_CXX_FLAGS_DEBUG  "-O0 -g -fno-omit-frame-pointer -fsanitize=address")
#SET(CMAKE_LINKER_FLAGS_DEBUG "${CMAKE_LINKER_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=address")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(ENZYME_ENABLE_PLUGINS "Enable Clang/LLD/Opt plugins" ON)
option(ENZYME_CLANG "Build enzyme clang plugin" ON)
option(ENZYME_FLANG "Build enzyme flang symlink" OFF)
option(ENZYME_MLIR "Build enzyme mlir plugin" OFF)
option(ENZYME_IFX "Enable enzyme support for the Intel Fortran compiler IFX" OFF)
option(ENZYME_EXTERNAL_SHARED_LIB "Build external shared library" OFF)
option(ENZYME_STATIC_LIB "Build static library" OFF)
set(ENZYME_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(ENZYME_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
list(APPEND CMAKE_MODULE_PATH "${ENZYME_SOURCE_DIR}/cmake/modules")

set(LLVM_SHLIBEXT "${CMAKE_SHARED_MODULE_SUFFIX}")
if (APPLE)
    set(LLVM_SHLIBEXT ".dylib")
endif()
message( LLVM_SHLIBEXT = ${LLVM_SHLIBEXT} )

set(LLVM_MAIN_SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}")

get_filename_component(LLVM_ABSOLUTE_DIR
    "${LLVM_DIR}"
    REALPATH BASE_DIR "${CMAKE_BINARY_DIR}")

if (NOT EXISTS "${LLVM_DIR}")
  message("Looking for LLVM_DIR at ${LLVM_DIR}")
  message(SEND_ERROR "The given LLVM_DIR does not exist. Typo?")
endif()

set(LLVM_DIR "${LLVM_ABSOLUTE_DIR}" CACHE FILEPATH "b" FORCE)

if (EXISTS "${LLVM_DIR}/lib/cmake/llvm/LLVMConfig.cmake")
  set(LLVM_DIR "${LLVM_DIR}/lib/cmake/llvm")
endif()

message("LLVM ABS DIR " ${LLVM_DIR})

message("CMAKE_PREFIX_PATH " ${CMAKE_PREFIX_PATH})

find_package(LLVM REQUIRED CONFIG)

if (NOT LLVM_ENABLE_PLUGINS)
  message("LLVM_ENABLE_PLUGINS OFF")
  message("Setting ENZYME_ENABLE_PLUGINS OFF")
  set(ENZYME_ENABLE_PLUGINS OFF)
endif()

if ((NOT ENZYME_EXTERNAL_SHARED_LIB) AND (NOT ENZYME_ENABLE_PLUGINS))
  message("ENZYME_EXTERNAL_SHARED_LIB OFF")
  message("ENZYME_ENABLE_PLUGINS OFF")
  message(SEND_ERROR "You have selected a build without creating the Enzyme plugin, nor Enzyme as a shared library -- and nothing will be built.")
endif()

if (NOT DEFINED LLVM_EXTERNAL_LIT)
  if(LLVM_DIR MATCHES ".*/cmake/llvm/?$")
      message("found llvm match ${CMAKE_MATCH_1} dir ${LLVM_DIR}")
    if (EXISTS ${LLVM_DIR}/../../../bin/llvm-lit)
      set(LLVM_EXTERNAL_LIT ${LLVM_DIR}/../../../bin/llvm-lit)
    else()
      set(LLVM_EXTERNAL_LIT lit)
    endif()
  else()
    if (EXISTS ${LLVM_DIR}/bin/llvm-lit)
      set(LLVM_EXTERNAL_LIT ${LLVM_DIR}/bin/llvm-lit)
    else()
      set(LLVM_EXTERNAL_LIT lit)
    endif()
  endif()
endif()

get_filename_component(LLVM_ABSOLUTE_LIT
                       "${LLVM_EXTERNAL_LIT}"
                       REALPATH BASE_DIR "${CMAKE_BINARY_DIR}")

                   set(LLVM_EXTERNAL_LIT "${LLVM_ABSOLUTE_LIT}" CACHE FILEPATH "a" FORCE)
message("found llvm lit " ${LLVM_EXTERNAL_LIT})

list(INSERT CMAKE_PREFIX_PATH 0 "${LLVM_DIR}")
message("LLVM dir ${LLVM_DIR}")
if (ENZYME_CLANG)
if (DEFINED Clang_DIR)
    get_filename_component(Clang_ABSOLUTE_DIR
      "${Clang_DIR}"
    REALPATH BASE_DIR "${CMAKE_BINARY_DIR}")
set(Clang_DIR "${Clang_ABSOLUTE_DIR}" CACHE FILEPATH "b" FORCE)
  list(INSERT CMAKE_PREFIX_PATH 0 "${Clang_DIR}")
  message("clang dir defined ${Clang_DIR}")
else()
  if(LLVM_DIR MATCHES ".*/cmake/llvm/?$")
    if (EXISTS ${LLVM_DIR}/../clang/../../libclangBasic.a)
      set(Clang_DIR ${LLVM_DIR}/../clang)
     list(INSERT CMAKE_PREFIX_PATH 0 "${Clang_DIR}")
    endif()
  elseif(LLVM_DIR MATCHES ".*/llvm-([0-9]+)/?$")
    if (EXISTS ${LLVM_DIR}/lib/libclangBasic.a)
      set(Clang_DIR ${LLVM_DIR}/lib/cmake/clang)
     list(INSERT CMAKE_PREFIX_PATH 0 "${Clang_DIR}")
    endif()
  elseif(LLVM_DIR MATCHES ".*/llvm-([0-9]+)/cmake/?$")
      get_filename_component(LLDIR "${LLVM_DIR}" DIRECTORY)
    if (EXISTS ${LLDIR}/lib/libclangBasic.a)
      set(Clang_DIR ${LLDIR}/lib/cmake/clang)
     list(INSERT CMAKE_PREFIX_PATH 0 "${Clang_DIR}")
    endif()
  else()
    if (EXISTS ${LLVM_DIR}/lib/libclangBasic.a)
      set(Clang_DIR ${LLVM_DIR})
      list(INSERT CMAKE_PREFIX_PATH 0 "${Clang_DIR}")
    endif()
  endif()
  message("clang dir from llvm ${Clang_DIR}")
endif()
else()
endif()

if (ENZYME_MLIR)
    if (DEFINED MLIR_DIR)
        get_filename_component(MLIR_ABSOLUTE_DIR
        "${MLIR_DIR}"
        REALPATH BASE_DIR "${CMAKE_BINARY_DIR}")
        set(MLIR_DIR "${MLIR_ABSOLUTE_DIR}" CACHE FILEPATH "b" FORCE)
        list(INSERT CMAKE_PREFIX_PATH 0 "${MLIR_DIR}")
        message("MLIR dir defined ${MLIR_DIR}")
    else()
      if(LLVM_DIR MATCHES ".*/cmake/llvm/?$")
        if (EXISTS ${LLVM_DIR}/../mlir/../../libMLIRIR.a)
            set(MLIR_DIR ${LLVM_DIR}/../mlir)
            list(INSERT CMAKE_PREFIX_PATH 0 "${MLIR_DIR}")
        else()
            message(SEND_ERROR "MLIR requested but not found")
        endif()
      elseif(LLVM_DIR MATCHES ".*/llvm-([0-9]+)/?$")
        if (EXISTS ${LLVM_DIR}/lib/libMLIRIR.a)
            set(MLIR_DIR ${LLVM_DIR}/lib/cmake/mlir)
          list(INSERT CMAKE_PREFIX_PATH 0 "${MLIR_DIR}")
        else()
            message(SEND_ERROR "MLIR requested but not found")
        endif()
      elseif(LLVM_DIR MATCHES ".*/llvm-([0-9]+)/cmake/?$")
          get_filename_component(LLDIR "${LLVM_DIR}" DIRECTORY)
        if (EXISTS ${LLDIR}/lib/libMLIRIR.a)
            set(MLIR_DIR ${LLDIR}/lib/cmake/mlir)
            list(INSERT CMAKE_PREFIX_PATH 0 "${MLIR_DIR}")
        else()
            message(SEND_ERROR "MLIR requested but not found")
        endif()
      else()
        if (EXISTS ${LLVM_DIR}/lib/libMLIRIR.a)
          set(MLIR_DIR ${LLVM_DIR})
          list(INSERT CMAKE_PREFIX_PATH 0 "${MLIR_DIR}")
        else()
            message(SEND_ERROR "MLIR requested but not found")
        endif()
      endif()
      message("mlir dir from llvm ${MLIR_DIR}")
    endif()
endif()

if(ENZYME_IFX)
    add_definitions(-DENZYME_IFX=1)
    message("Building with support for the Intel Fortran compiler IFX")
endif()

list(APPEND CMAKE_MODULE_PATH "${LLVM_CMAKE_DIR}")
include(AddLLVM)

message("clang dir ${Clang_DIR}")
message("mlir dir ${MLIR_DIR}")

if (DEFINED Clang_DIR)
    find_package(Clang REQUIRED CONFIG PATHS ${Clang_DIR} NO_DEFAULT_PATH)
if (${Clang_FOUND})
    include_directories(${CLANG_INCLUDE_DIRS})
    message("clang inc dir ${CLANG_INCLUDE_DIRS}")
    add_definitions(${CLANG_DEFINITIONS})
endif()
else()
    set(Clang_FOUND 0)
endif()
message("found Clang ${Clang_FOUND}")

if (DEFINED MLIR_DIR)
    find_package(MLIR REQUIRED CONFIG PATHS ${MLIR_DIR} NO_DEFAULT_PATH)
    if (${MLIR_FOUND})
        include_directories(${MLIR_INCLUDE_DIRS})
        message("MLIR inc dir ${MLIR_INCLUDE_DIRS}")
        add_definitions(${MLIR_DEFINITIONS})
        add_definitions(-DENZYME_MLIR=1)
        list(APPEND CMAKE_MODULE_PATH "${MLIR_CMAKE_DIR}")
        include(TableGen)
        include(AddMLIR)
    endif()
else()
    set(MLIR_FOUND 0)
endif()
message("found MLIR ${MLIR_FOUND}")
# include(AddClang)

add_definitions(${LLVM_DEFINITIONS})
include_directories(${LLVM_INCLUDE_DIRS})
message("LLVM_INSTALL_PREFIX: ${LLVM_INSTALL_PREFIX}")
message("LLVM_INCLUDE_DIRS: ${LLVM_INCLUDE_DIRS}")
message("found LLVM definitions " ${LLVM_DEFINITIONS})
message("found LLVM version " ${LLVM_VERSION_MAJOR})

if(LLVM_VERSION_MAJOR LESS 15)
  message(FATAL_ERROR "LLVM version < 15 is not supported")
endif()

option(ENZYME_FLANG_VERSION "Build for non-version compliant FLANG" OFF)
if (ENZYME_FLANG_VERSION)
  add_definitions(-DFLANG=1)
endif()

option(ENZYME_ROCM_VERSION "Build for non-version compliant ROCM" OFF)
if (ENZYME_ROCM_VERSION)
  add_definitions(-DROCM=1)
endif()

# Offer the user the choice of overriding the installation directories
set(INSTALL_INCLUDE_DIR include CACHE PATH "Installation directory for header files")
if(WIN32 AND NOT CYGWIN)
  set(DEF_INSTALL_CMAKE_DIR CMake)
else()
  set(DEF_INSTALL_CMAKE_DIR lib/cmake/Enzyme)
endif()
set(INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH
  "Installation directory for CMake files")


list(GET LLVM_INCLUDE_DIRS 0 LLVM_IDIR)
message("first llvm include directory" ${LLVM_IDIR})

file(READ ${LLVM_IDIR}/llvm/Analysis/ScalarEvolution.h INPUT_TEXT)
string(REPLACE private public INPUT_TEXT "${INPUT_TEXT}")
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/include/SCEV/ScalarEvolution.h" "${INPUT_TEXT}")


file(READ ${LLVM_IDIR}/llvm/Analysis/TargetLibraryInfo.h INPUT_TEXT)
string(REPLACE "class TargetLibraryInfo {" "class TargetLibraryInfo {public:" INPUT_TEXT "${INPUT_TEXT}")
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/include/SCEV/TargetLibraryInfo.h" "${INPUT_TEXT}")

file(READ ${LLVM_IDIR}/llvm/Transforms/Utils/ScalarEvolutionExpander.h INPUT_TEXT)

find_library(MPFR_LIB_PATH mpfr)
CHECK_INCLUDE_FILE("mpfr.h" HAS_MPFR_H)
message("MPFR lib: " ${MPFR_LIB_PATH})
message("MPFR header: " ${HAS_MPFR_H})

file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/include/SCEV/ScalarEvolutionExpander.h" "${INPUT_TEXT}")

include_directories("${CMAKE_CURRENT_BINARY_DIR}/include")

add_subdirectory(tools)
add_subdirectory(Enzyme)
add_subdirectory(BCLoad)
if (ENZYME_ENABLE_PLUGINS)
    add_subdirectory(test)
endif()

# The benchmarks data are not in git-exported source archives to minimize size.
# Only add the benchmarks if the directory exists.
if (ENZYME_ENABLE_PLUGINS AND (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/benchmarks"))
    add_subdirectory(benchmarks)
endif()

# Make relative paths absolute (needed later on)
foreach(p LIB BIN INCLUDE CMAKE)
set(var INSTALL_${p}_DIR)
if(NOT IS_ABSOLUTE "${${var}}")
  set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
endif()
endforeach()

if (ENZYME_ENABLE_PLUGINS)
export(TARGETS LLVMEnzyme-${LLVM_VERSION_MAJOR}
  FILE "${PROJECT_BINARY_DIR}/EnzymeTargets.cmake")

if (${Clang_FOUND})
export(TARGETS ClangEnzyme-${LLVM_VERSION_MAJOR}
    APPEND FILE "${PROJECT_BINARY_DIR}/EnzymeTargets.cmake")
export(TARGETS ClangEnzymeFlags
    APPEND FILE "${PROJECT_BINARY_DIR}/EnzymeTargets.cmake")

file(GLOB_RECURSE ENZYME_INCLUDES CONFIGURE_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/include/*")
set(bundled_includes "${CMAKE_CURRENT_BINARY_DIR}/Enzyme/Clang/bundled_includes.h")
list(APPEND ENZYME_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/scripts/bundle-includes.sh)
add_custom_command(OUTPUT ${bundled_includes}
  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/scripts/bundle-includes.sh
  ${CMAKE_CURRENT_SOURCE_DIR}/include/enzyme/enzyme
  ${bundled_includes}
  DEPENDS ${ENZYME_INCLUDES}
  COMMENT "Bundling includes"
  VERBATIM
)
add_custom_target(bundled_includes_target DEPENDS ${bundled_includes})
add_dependencies(ClangEnzyme-${LLVM_VERSION_MAJOR} bundled_includes_target)
target_include_directories(ClangEnzyme-${LLVM_VERSION_MAJOR} PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/Enzyme/Clang/")
endif()
endif()

if (${ENZYME_FLANG} AND ${Clang_FOUND})
	add_custom_target(link_target ALL
  COMMAND ${CMAKE_COMMAND} -E create_symlink
	  ClangEnzyme-${LLVM_VERSION_MAJOR}${LLVM_SHLIBEXT}

=== src/tools/enzyme/enzyme/test/test_find_package/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(enzyme_consumer LANGUAGES C)

find_package(Enzyme REQUIRED CONFIG NO_DEFAULT_PATH)
message("found dir ${Enzyme_DIR}")
message("found ${Enzyme_FOUND}")
get_property(importTargetsAfter DIRECTORY "${CMAKE_SOURCE_DIR}" PROPERTY IMPORTED_TARGETS)
message("imported targets ${importTargetsAfter}")

#add_subdirectory(${Enzyme_DIR} ${PROJECT_SOURCE_DIR}/build/enzyme)

add_executable(enzyme_test_1 main.c)
target_link_libraries(enzyme_test_1 PUBLIC ClangEnzymeFlags)

add_executable(enzyme_test_2 main.c)
target_compile_definitions(enzyme_test_2 PUBLIC -DNOVERSION)
target_link_libraries(enzyme_test_2 PUBLIC LLDEnzymeFlags)

=== src/tools/enzyme/enzyme/Enzyme/MLIR/Dialect/CMakeLists.txt ===
add_mlir_dialect(EnzymeOps enzyme)
add_mlir_doc(EnzymeDialect -gen-dialect-doc EnzymeDialect Enzyme/)
add_mlir_doc(EnzymeOps -gen-op-doc EnzymeOps Enzyme/)

set(LLVM_TARGET_DEFINITIONS EnzymeOps.td)
mlir_tablegen(EnzymeEnums.h.inc -gen-enum-decls)
mlir_tablegen(EnzymeEnums.cpp.inc -gen-enum-defs)
mlir_tablegen(EnzymeAttributes.h.inc -gen-attrdef-decls -attrdefs-dialect=enzyme)
mlir_tablegen(EnzymeAttributes.cpp.inc -gen-attrdef-defs -attrdefs-dialect=enzyme)
add_public_tablegen_target(MLIREnzymeEnumsIncGen)

add_mlir_dialect_library(MLIREnzyme
Dialect.cpp
Ops.cpp

ADDITIONAL_HEADER_DIRS

DEPENDS
MLIREnzymeOpsIncGen
MLIREnzymeEnumsIncGen

LINK_LIBS PUBLIC
MLIRIR
MLIRMemRefDialect
)

=== src/tools/enzyme/enzyme/Enzyme/MLIR/Implementations/CMakeLists.txt ===
set(LLVM_TARGET_DEFINITIONS AffineDerivatives.td)
enzyme_tablegen(AffineDerivatives.inc -gen-mlir-derivatives)
add_public_tablegen_target(AffineDerivativesIncGen)

set(LLVM_TARGET_DEFINITIONS ArithDerivatives.td)
enzyme_tablegen(ArithDerivatives.inc -gen-mlir-derivatives)
add_public_tablegen_target(ArithDerivativesIncGen)

set(LLVM_TARGET_DEFINITIONS LLVMDerivatives.td)
enzyme_tablegen(LLVMDerivatives.inc -gen-mlir-derivatives)
add_public_tablegen_target(LLVMDerivativesIncGen)

set(LLVM_TARGET_DEFINITIONS NVVMDerivatives.td)
enzyme_tablegen(NVVMDerivatives.inc -gen-mlir-derivatives)
add_public_tablegen_target(NVVMDerivativesIncGen)

set(LLVM_TARGET_DEFINITIONS SCFDerivatives.td)
enzyme_tablegen(SCFDerivatives.inc -gen-mlir-derivatives)
add_public_tablegen_target(SCFDerivativesIncGen)

set(LLVM_TARGET_DEFINITIONS CFDerivatives.td)
enzyme_tablegen(CFDerivatives.inc -gen-mlir-derivatives)
add_public_tablegen_target(CFDerivativesIncGen)

set(LLVM_TARGET_DEFINITIONS MemRefDerivatives.td)
enzyme_tablegen(MemRefDerivatives.inc -gen-mlir-derivatives)
add_public_tablegen_target(MemRefDerivativesIncGen)

set(LLVM_TARGET_DEFINITIONS ComplexDerivatives.td)
enzyme_tablegen(ComplexDerivatives.inc -gen-mlir-derivatives)
add_public_tablegen_target(ComplexDerivativesIncGen)

set(LLVM_TARGET_DEFINITIONS MathDerivatives.td)
enzyme_tablegen(MathDerivatives.inc -gen-mlir-derivatives)
add_public_tablegen_target(MathDerivativesIncGen)

set(LLVM_TARGET_DEFINITIONS FuncDerivatives.td)
enzyme_tablegen(FuncDerivatives.inc -gen-mlir-derivatives)
add_public_tablegen_target(FuncDerivativesIncGen)

add_mlir_library(MLIREnzymeImplementations
  AffineAutoDiffOpInterfaceImpl.cpp
  ArithAutoDiffOpInterfaceImpl.cpp
  CoreDialectsAutoDiffImplementations.cpp
  LLVMAutoDiffOpInterfaceImpl.cpp
  NVVMAutoDiffOpInterfaceImpl.cpp
  MemRefAutoDiffOpInterfaceImpl.cpp
  ComplexAutoDiffOpInterfaceImpl.cpp
  FuncAutoDiffOpInterfaceImpl.cpp
  LinalgAutoDiffOpInterfaceImpl.cpp
  BuiltinAutoDiffTypeInterfaceImpl.cpp
  SCFAutoDiffOpInterfaceImpl.cpp
  CFAutoDiffOpInterfaceImpl.cpp
  MathAutoDiffOpInterfaceImpl.cpp

  DEPENDS
  MLIRAutoDiffOpInterfaceIncGen
  AffineDerivativesIncGen
  ArithDerivativesIncGen
  ComplexDerivativesIncGen
  LLVMDerivativesIncGen
  FuncDerivativesIncGen
  NVVMDerivativesIncGen
  SCFDerivativesIncGen
  CFDerivativesIncGen
  MemRefDerivativesIncGen
  MathDerivativesIncGen

  LINK_LIBS PUBLIC
  MLIRArithDialect
  MLIRFuncDialect
  MLIRComplexDialect
  MLIRLLVMDialect
  MLIRMemRefDialect
  MLIREnzymeAutoDiffInterface
  MLIRIR
  MLIRSCFDialect
  MLIRLinalgDialect
)

=== src/tools/enzyme/enzyme/Enzyme/MLIR/Passes/CMakeLists.txt ===
set(LLVM_TARGET_DEFINITIONS Passes.td)
mlir_tablegen(Passes.h.inc -gen-pass-decls -name enzyme)
add_public_tablegen_target(MLIREnzymePassIncGen)
add_mlir_doc(Passes EnzymePasses ./ -gen-pass-doc)

add_mlir_dialect_library(MLIREnzymeTransforms
    EnzymeMLIRPass.cpp
    EnzymeBatchPass.cpp
    EnzymeWrapPass.cpp
    PrintActivityAnalysis.cpp
    PrintAliasAnalysis.cpp
    EnzymeToMemRef.cpp
    SimplifyMath.cpp
    AddToOpToIndexAndLoad.cpp
    AddToOpToSplit.cpp
    RemovalUtils.cpp
    RemoveUnusedEnzymeOps.cpp
    SimplifyMemrefCache.cpp
    Utils.cpp
  
  ADDITIONAL_HEADER_DIRS
  ${MLIR_MAIN_INCLUDE_DIR}/mlir/Dialect/Affine

  DEPENDS
  MLIREnzymePassIncGen

  LINK_LIBS PUBLIC
  MLIRAffineDialect
  MLIRArithDialect
  MLIRAsyncDialect
  MLIRAffineUtils
  MLIRFuncDialect
  MLIRFuncTransforms
  MLIRGPUDialect
  MLIRTensorDialect
  MLIRIR
  MLIRLLVMDialect
  MLIRMathDialect
  MLIRMathToLLVM
  MLIRMemRefDialect
  MLIRNVVMDialect
  MLIRPass
  MLIRSideEffectInterfaces
  MLIRControlFlowInterfaces
  MLIRSCFToControlFlow
  MLIRTransformUtils

  MLIREnzymeAutoDiffInterface
)

=== src/tools/enzyme/enzyme/test/Enzyme/ReverseMode/CMakeLists.txt ===
# Run regression and unit tests
add_lit_testsuite(check-enzyme-reverse "Running enzyme reverse mode regression tests"
    ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${ENZYME_TEST_DEPS}
    ARGS -v
)

set_target_properties(check-enzyme-reverse PROPERTIES FOLDER "Tests")

#add_lit_testsuites(ENZYME ${CMAKE_CURRENT_SOURCE_DIR}
    #    DEPENDS ${ENZYME_TEST_DEPS}
#)

=== debian/control ===
--- 
+++ 
@@ -17,6 +17,10 @@
  python3:native,
  cargo-1.88 | cargo-1.89 <!pkg.rustc.dlstage0>,
  rustc-1.88 | rustc-1.89 <!pkg.rustc.dlstage0>,
+ llvm-20-dev:native,
+ llvm-20-tools:native,
+ libclang-rt-20-dev (>= 1:20.1.2),
+ libclang-common-20-dev (>= 1:20.1.2),
  cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
  pkgconf,
@@ -29,15 +33,11 @@
  bash-completion,
  libcurl4-gnutls-dev | libcurl4-openssl-dev,
  libssh2-1-dev,
- libgit2-dev (>= 1.7.2~~),
- libgit2-dev (<< 1.8~~),
+ libgit2-dev (>= 1.9.0~~),
+ libgit2-dev (<< 1.10~~),
  libhttp-parser-dev,
  libsqlite3-dev,
  libonig-dev,
-# Required for llvm build
- autotools-dev,
- m4,
- ninja-build,
 # test dependencies:
  binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
  git <!nocheck>,
@@ -55,6 +55,7 @@
  curl <pkg.rustc.dlstage0>,
  ca-certificates <pkg.rustc.dlstage0>,
 Build-Depends-Indep:
+ clang-20:native,
  libssl-dev,
 Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
 Standards-Version: 4.6.2

=== debian/rules ===
--- 
+++ 
@@ -26,11 +26,6 @@
 # The upstream source code version.
 DEFINED_SRC_VERSION := $(shell cut -f1 -d' ' < $(CURDIR)/version)
 
-VENDOR_TARBALL := $(PKG_NAME_CHANGELOG)_$(DEB_VERSION_UPSTREAM).orig-vendor.tar.xz
-# This is a temporary directory used to store the filtered vendored dependencies.
-# It is packed into the vendor tarball.
-FILTERED_DEPS := $(CURDIR)/../vendor
-
 include /usr/share/dpkg/buildflags.mk
 # needed for cross-compilation to avoid passing host CFLAGS to the BUILD
 # compiler
@@ -46,12 +41,6 @@
 # for dh_install substitution variable
 export DEB_HOST_RUST_TYPE
 
-# Let rustbuild control whether LLVM is compiled with debug symbols, rather
-# than compiling with debug symbols unconditionally, which will fail on
-# 32-bit architectures
-CFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
-CXXFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
-
 # for dh_install substitution variable
 export RUST_LONG_VERSION
 export RUST_VERSION
@@ -59,25 +48,30 @@
 DEB_DESTDIR := $(CURDIR)/debian/tmp
 
 # Use system LLVM (comment out to use vendored LLVM)
-# LLVM_VERSION = 20
-# OLD_LLVM_VERSION = $(shell echo "$$(($(LLVM_VERSION)-1))")
-# # used by the upstream profiler build script
-# CLANG_RT_TRIPLE := $(shell llvm-config-$(LLVM_VERSION) --host-target)
-# LLVM_PROFILER_RT_LIB = /usr/lib/clang/$(LLVM_VERSION)/lib/$(CLANG_RT_TRIPLE)/libclang_rt.profile.a
-# ifneq ($(wildcard $(LLVM_PROFILER_RT_LIB)),)
-# # Clang per-target layout
-# export LLVM_PROFILER_RT_LIB := /../../$(LLVM_PROFILER_RT_LIB)
-# else
-# # Clang legacy layout
-# CLANG_RT_ARCH := $(shell echo '$(CLANG_RT_TRIPLE)' | cut -f1 -d-)
-# ifeq ($(DEB_HOST_ARCH),armhf)
-# CLANG_RT_ARCH := armhf
-# endif
-# export LLVM_PROFILER_RT_LIB := /usr/lib/clang/$(LLVM_VERSION)/lib/linux/libclang_rt.profile-$(CLANG_RT_ARCH).a
-# endif
-
+LLVM_VERSION = 20
+OLD_LLVM_VERSION = $(shell echo "$$(($(LLVM_VERSION)-1))")
+# used by the upstream profiler build script
+CLANG_RT_TRIPLE := $(shell llvm-config-$(LLVM_VERSION) --host-target)
+LLVM_PROFILER_RT_LIB = /usr/lib/clang/$(LLVM_VERSION)/lib/$(CLANG_RT_TRIPLE)/libclang_rt.profile.a
+ifneq ($(wildcard $(LLVM_PROFILER_RT_LIB)),)
+# Clang per-target layout
+export LLVM_PROFILER_RT_LIB := /../../$(LLVM_PROFILER_RT_LIB)
+else
+# Clang legacy layout
+CLANG_RT_ARCH := $(shell echo '$(CLANG_RT_TRIPLE)' | cut -f1 -d-)
+ifeq ($(DEB_HOST_ARCH),armhf)
+CLANG_RT_ARCH := armhf
+endif
+export LLVM_PROFILER_RT_LIB := /usr/lib/clang/$(LLVM_VERSION)/lib/linux/libclang_rt.profile-$(CLANG_RT_ARCH).a
+endif
 # Cargo-specific flags
 export LIBSSH2_SYS_USE_PKG_CONFIG=1
+# Make it easier to test against a custom LLVM
+ifneq (,$(LLVM_DESTDIR))
+LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
+LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
+export LD_LIBRARY_PATH
+endif
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 ifeq ($(DEB_HOST_ARCH),riscv64)
@@ -106,23 +100,6 @@
 ifneq (,$(RUST_TEST_SELFBUILD))
 RUST_BOOTSTRAP_DIR = /usr/lib/rust-$(RUST_VERSION)
 endif
-
-.PHONY: vendor-tarball-quick-check
-vendor-tarball-quick-check:
-	if [ -e $(CURDIR)/../$(VENDOR_TARBALL) ]; then \
-		echo "../$(VENDOR_TARBALL) already exists" >&2; \
-		exit 1; \
-	fi
-
-.PHONY: vendor-deps
-vendor-deps:
-	debian/vendor-deps $(FILTERED_DEPS)
-
-.PHONY: vendor-tarball
-vendor-tarball: vendor-tarball-quick-check vendor-deps
-	tar --sort=name --mtime=@0 --owner=0 --group=0 --numeric-owner --pax-option=exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime -caf $(CURDIR)/../$(VENDOR_TARBALL) $(FILTERED_DEPS)
-	mk-origtargz --rename -c vendor $(CURDIR)/../$(VENDOR_TARBALL)
-	rm -rf $(FILTERED_DEPS)
 
 update-version: check-changelog-matches-upstream
 ifeq ($(PKG_NAME_CONTROL),rustc-$(RUST_VERSION))
@@ -182,3 +159,39 @@
     ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
     ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
         PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
+          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
+    endif
+    endif
+endif
+
+BUILD_DOCS := true
+ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
+  BUILD_DOCS := false
+endif
+ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
+  BUILD_DOCS := false
+endif
+
+BUILD_WASM := false
+
+BUILD_WINDOWS := false
+
+MAKE_OPTIMISATIONS := true
+ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
+  MAKE_OPTIMISATIONS := false
+endif
+
+VERBOSITY_SUB := $(words $(filter terse,$(DEB_BUILD_OPTIONS)))
+VERBOSITY_ADD := $(words $(filter verbose,$(DEB_BUILD_OPTIONS)))
+VERBOSITY := $(shell expr 2 + $(VERBOSITY_ADD) - $(VERBOSITY_SUB))
+
+ifeq ($(shell test $(VERBOSITY) -ge 3; echo $$?),0)
+  export DH_VERBOSE=1
+endif
+
+ifeq ($(shell test $(VERBOSITY) -le 0; echo $$?),0)
+  export DH_QUIET=1
+.SILENT:
+endif
+
+# Build products or non-source files in src/, that shouldn't go in rust-src

=== debian/tests/control ===
Test-Command: ./debian/rules build RUST_TEST_SELFBUILD=1
Depends: @, @builddeps@
Restrictions: rw-build-tree, allow-stderr

Tests: create-and-build-crate
Restrictions: rw-build-tree, allow-stderr
Depends: @builddeps@

## rustc-1.89 1.89.0+dfsg0ubuntu2

=== debian/rules ===
--- 
+++ 
@@ -25,6 +25,11 @@
 PKG_NAME_CONTROL := $(shell sed -n 's/^Source: \(rustc-[0-9][0-9.]\+\).*/\1/p' debian/control)
 # The upstream source code version.
 DEFINED_SRC_VERSION := $(shell cut -f1 -d' ' < $(CURDIR)/version)
+
+VENDOR_TARBALL := $(PKG_NAME_CHANGELOG)_$(DEB_VERSION_UPSTREAM).orig-vendor.tar.xz
+# This is a temporary directory used to store the filtered vendored dependencies.
+# It is packed into the vendor tarball.
+FILTERED_DEPS := $(CURDIR)/../vendor
 
 include /usr/share/dpkg/buildflags.mk
 # needed for cross-compilation to avoid passing host CFLAGS to the BUILD
@@ -101,6 +106,23 @@
 RUST_BOOTSTRAP_DIR = /usr/lib/rust-$(RUST_VERSION)
 endif
 
+.PHONY: vendor-tarball-quick-check
+vendor-tarball-quick-check:
+	if [ -e $(CURDIR)/../$(VENDOR_TARBALL) ]; then \
+		echo "../$(VENDOR_TARBALL) already exists" >&2; \
+		exit 1; \
+	fi
+
+.PHONY: vendor-deps
+vendor-deps:
+	debian/vendor-deps $(FILTERED_DEPS)
+
+.PHONY: vendor-tarball
+vendor-tarball: vendor-tarball-quick-check vendor-deps
+	tar --sort=name --mtime=@0 --owner=0 --group=0 --numeric-owner --pax-option=exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime -caf $(CURDIR)/../$(VENDOR_TARBALL) $(FILTERED_DEPS)
+	mk-origtargz --rename -c vendor $(CURDIR)/../$(VENDOR_TARBALL)
+	rm -rf $(FILTERED_DEPS)
+
 update-version: check-changelog-matches-upstream
 ifeq ($(PKG_NAME_CONTROL),rustc-$(RUST_VERSION))
 	$(error The source package version in d/control already matches the upstream code version)
@@ -159,39 +181,3 @@
     ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
     ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
         PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
-          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
-    endif
-    endif
-endif
-
-BUILD_DOCS := true
-ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
-  BUILD_DOCS := false
-endif
-ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
-  BUILD_DOCS := false
-endif
-
-BUILD_WASM := false
-
-BUILD_WINDOWS := false
-
-MAKE_OPTIMISATIONS := true
-ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-  MAKE_OPTIMISATIONS := false
-endif
-
-VERBOSITY_SUB := $(words $(filter terse,$(DEB_BUILD_OPTIONS)))
-VERBOSITY_ADD := $(words $(filter verbose,$(DEB_BUILD_OPTIONS)))
-VERBOSITY := $(shell expr 2 + $(VERBOSITY_ADD) - $(VERBOSITY_SUB))
-
-ifeq ($(shell test $(VERBOSITY) -ge 3; echo $$?),0)
-  export DH_VERBOSE=1
-endif
-
-ifeq ($(shell test $(VERBOSITY) -le 0; echo $$?),0)
-  export DH_QUIET=1
-.SILENT:
-endif
-
-# Build products or non-source files in src/, that shouldn't go in rust-src
